;*******************************************Handle Bomb
;*
;*	called by mainloop to do processes on this bomb
;*
;*	Input:	d6=the # of this bonb in the bomb array
;*
;********
bomberd4@0004:
handle_bomb:
	bsr	learn_bomb
	cmp.w	#1,o
	beq		enemy_owned_no_triggers
	cmp.w	#1,bomberd2::bombs_are_triggered	;if bonbs are triggered, kill this one
	beq	explode_bomb
	enemy_owned_no_triggers:

	cmp.w	#1,o
	beq		timer_on_bomb
	cmp.w	#1,bomberd2::trigger_bombs	;don't count down for triggers
	beq	no_timer_on_bomb
timer_on_bomb:
	subq.w	#1,es
	cmp.w	#0,es
	beq		explode_bomb
no_timer_on_bomb:

	addq.w	#1,s
	cmp.w	#4,s
	bne		hb_dont_reset
	move.w	#0,s
hb_dont_reset:

	move.w	s,(a4)
	move.w	es,(a5)
	rts

learn_bomb:
	lea	bomberd2::bomb_x,a0		;Get bomb d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::bomb_y,a0		;Get bomb d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::bomb_s,a0		;Get bomb d6's s
	lea	0(a0,d2.w),a4

	lea	bomberd2::bomb_es,a0		;Get bomb d6's es
	lea	0(a0,d2.w),a5

	lea	bomberd2::bomb_o,a0		;Get bomb d6's o
	lea	0(a0,d2.w),a6

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),es
	move.w	(a6),o

	SetExtraPosInfo x,y

	subq.w	#8,x
	subq.w	#8,y
	rts

bomberd4@0005:
draw_bomb:
	bsr	learn_bomb
		;draw the bomb sprite
	cmp.w	#0,s
	beq		hb_s1
	cmp.w	#1,s
	beq		hb_s2
	cmp.w	#2,s
	beq		hb_s3
	cmp.w	#3,s
	beq		hb_s2
	rts

hb_s1:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_bomb1,x,y,#16
	rts

hb_s2:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_bomb2,x,y,#16
	rts

hb_s3:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_bomb3,x,y,#16
	rts

;*******************************************Explode Bomb
;*
;*	Explodes and Deletes a bomb from the bomb array
;*
;*	Input:	d6=the # of this bomb in the bomb array
;*
;********
bomberd4@0006:
explode_bomb:
	movem.l	d0-d3/a0-a3,-(a7)

	move.w	bomberd2::bomb_exp_len,d0
	move.w	d0,explen

	cmp.w	#0,o
	beq		eb_not_enemy_owner
		move.w	#2,explen
	eb_not_enemy_owner:

		;add explosions downward
	clr.w	d2
	move.w	eblock_y,d1
	addq.w	#1,d1
	move.w	#0,tmp
db_add_vexp_down_loop:
	move.w	eblock_x,d0
	GetBoard d3
	cmp.w	#2,d3					;I hit undestr. wall
	beq		db_exit_add_vexp_down_loop
	cmp.w	bomberd2::map_height,d1
	bhi		db_exit_add_vexp_down_loop
	cmp.w	explen,d2
	beq		db_exit_add_vexp_down_loop
	cmp.w	#1,d3						;I hit a destructable wall
	beq		db_exit_add_vexp_down_loop_w_score_inc
	cmp.w	#3,d3
	beq		db_add_vexp_down_loop_got_bomb
	cmp.w	#4,d3
	beq		db_add_vexp_down_loop_got_bomb
	cmp.w	#0,d3
	bne		db_exit_add_vexp_down_loop
db_add_vexp_down_loop_got_bomb:
	move.w	d0,x
	move.w	d1,y
	bsr		add_vexp
	cmp.w	#3,d3
	beq		db_exit_add_vexp_down_loop		;I hit a bomb
	addq.w	#1,d1
	addq.w	#1,d2
	bra		db_add_vexp_down_loop
db_exit_add_vexp_down_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_vexp_down_loop:

		;add explosions upwards
	clr.w	d2
	move.w	#1,tmp
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	subq.w	#1,d1
	cmp.w	#0,eblock_y
	beq		db_exit_add_vexp_up_loop
db_add_vexp_up_loop:
	GetBoard d3
	cmp.w	#2,d3
	beq		db_exit_add_vexp_up_loop
	cmp.w	explen,d2
	beq		db_exit_add_vexp_up_loop
	cmp.w	#1,d3
	beq		db_exit_add_vexp_up_loop_w_score_inc
	cmp	#3,d3
	beq		db_add_vexp_up_loop_got_bomb
	cmp	#4,d3
	beq		db_add_vexp_up_loop_got_bomb
	cmp.w	#0,d3
	bne		db_exit_add_vexp_up_loop
db_add_vexp_up_loop_got_bomb:
	move.w	d1,y
	move.w	d0,x
	bsr		add_vexp
	cmp.w	#3,d3
	beq		db_exit_add_vexp_up_loop		;I hit a bomb
	addq.w	#1,d2
	cmp.w	#0,d1
	beq		db_exit_add_vexp_up_loop
	subq.w	#1,d1
	bra		db_add_vexp_up_loop
db_exit_add_vexp_up_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_vexp_up_loop:

		;add explosions to the right
	clr.w	d2
	move.w	eblock_x,d0
	addq.w	#1,d0
	move.w	#0,tmp
db_add_hexp_right_loop:
	move.w	eblock_y,d1
	GetBoard d3
	cmp.w	#2,d3
	beq		db_exit_add_hexp_right_loop
	cmp.w	bomberd2::map_width,d0
	bhi		db_exit_add_hexp_right_loop
	cmp.w	explen,d2
	beq		db_exit_add_hexp_right_loop
	cmp.w	#1,d3
	beq		db_exit_add_hexp_right_loop_w_score_inc
	cmp.w	#3,d3
	beq		db_add_hexp_right_loop_got_bomb
	cmp.w	#4,d3
	beq		db_add_hexp_right_loop_got_bomb
	cmp.w	#0,d3
	bne		db_exit_add_hexp_right_loop
db_add_hexp_right_loop_got_bomb:
	move.w	d0,x
	move.w	d1,y
	bsr		add_hexp
	cmp.w	#3,d3
	beq		db_exit_add_hexp_right_loop		;I hit a bomb
	addq.w	#1,d0
	addq.w	#1,d2
	bra		db_add_hexp_right_loop
db_exit_add_hexp_right_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_hexp_right_loop:

		;add explosions to the left
	clr.w	d2
	move.w	#1,tmp
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	subq.w	#1,d0
	cmp.w	#0,eblock_x
	beq		db_exit_add_hexp_left_loop
db_add_hexp_left_loop:
	GetBoard d3
	cmp.w	#2,d3
	beq		db_exit_add_hexp_left_loop
	cmp.w	explen,d2
	beq		db_exit_add_hexp_left_loop
	cmp.w	#1,d3
	beq		db_exit_add_hexp_left_loop_w_score_inc
	cmp.w	#3,d3
	beq		db_add_hexp_left_loop_got_bomb
	cmp.w	#4,d3
	beq		db_add_hexp_left_loop_got_bomb
	cmp.w	#0,d3
	bne		db_exit_add_hexp_left_loop
db_add_hexp_left_loop_got_bomb:
	move.w	d1,y
	move.w	d0,x
	bsr		add_hexp
	cmp.w	#3,d3
	beq		db_exit_add_hexp_left_loop		;I hit a bomb
	addq.w	#1,d2
	cmp.w	#0,d0
	beq		db_exit_add_hexp_left_loop
	subq.w	#1,d0
	bra		db_add_hexp_left_loop
db_exit_add_hexp_left_loop_w_score_inc:
	add.w	#10,bomberd2::score
	move.w	d0,x
	move.w	d1,y
	bsr	add_bexp
db_exit_add_hexp_left_loop:

	move.w	eblock_x,x	;add xexp to where the bomb was
	move.w	eblock_y,y
	bsr		add_xexp
	movem.l	(a7)+,d0-d3/a0-a3
	bsr		delete_bomb
	rts

;*******************************************Delete Bomb
;*
;*	Deletes a bomb from the bomb array
;*
;*	Input:	d6=the # of this bomb in the bomb array
;*
;********
bomberd4@0007:
delete_bomb:
	movem.l	d0-d3/a0-a6,-(a7)
	bsr		learn_bomb
	move.w	eblock_x,d0
	move.w	eblock_y,d1
	SetBoardL	#0

	lea	bomberd2::bomb_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::bomb_y,a1
	lea	0(a1,d0.w),a1

	lea	bomberd2::bomb_s,a2
	lea	0(a2,d0.w),a2

	lea	bomberd2::bomb_es,a3
	lea	0(a3,d0.w),a3

	lea	bomberd2::bomb_o,a4
	lea	0(a4,d0.w),a4

	move.w	bomberd2::bombcount,d1
	sub.w	d6,d1
	subq.w	#1,d1

		;shift the bomb array to cover the deleted bomb
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
	addq.w	#$02,a3
	addq.w	#$02,a4
db_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2
	move.w	(a3),d0
	subq.w	#$02,a3
	move.w	d0,(a3)
	addq.w	#$04,a3
	move.w	(a4),d0
	subq.w	#$02,a4
	move.w	d0,(a4)
	addq.w	#$04,a4

	dbra.w	d1,db_loop

	subq.w	#1,bomberd2::bombcount

	cmp.w	#0,o
	bne		db_not_player_bomb
	subq.w	#1,bomberd2::playerbombcount
	db_not_player_bomb:

	movem.l	(a7)+,d0-d3/a0-a6
	rts

;*******************************************Add Bomb
;*
;*	called by mainloop to do processes on this bomb
;*
;*	Input:	x=the x-coordinate of the new bomb in blocks
;*		y=the y-coordinate of the new bomb in blocks
;*		o=owner   0=player, 1=enemy
;*
;********
bomberd4@0008:
add_bomb:
	movem.l	d0-d2/a0,-(a7)

	move.w	x,d0
	move.w	y,d1

	GetBoard d2
	cmp.w	#1,d2
	beq	cancel_add_bomb

	lea	bomberd2::bomb_x,a0		;Set bomb x
	move.w  bomberd2::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::bomb_y,a0		;Set bomb y
	move.w  bomberd2::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	move.w	x,d0
	move.w	y,d1
	SetBoardL	#3

	lea	bomberd2::bomb_s,a0		;Set bomb s
	move.w  bomberd2::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	#0,(a0)

	lea	bomberd2::bomb_es,a0		;Set bomb es
	move.w  bomberd2::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomberd2::bomblife,(a0)

	lea	bomberd2::bomb_o,a0		;Set bomb o
	move.w  bomberd2::bombcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	o,(a0)

	addq.w	#1,bomberd2::bombcount
	cmp.w	#0,o
	bne		add_bomb_not_player_bomb
	addq.w	#1,bomberd2::playerbombcount
	move.w	bomberd2::playerbombcount,d2
	add_bomb_not_player_bomb:

cancel_add_bomb:
	movem.l	(a7)+,d0-d2/a0
	rts




;bomb sprite 1
sprite_bomb1:	
	dc.b	%00000000,%00000100
	dc.b	%00000000,%00001010
	dc.b	%00000011,%10001010
	dc.b	%00001111,%11110100
	dc.b	%00011111,%11101100
	dc.b	%00111011,%01011000
	dc.b	%00110010,%00111000
	dc.b	%01110111,%01111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00011111,%11110000
	dc.b	%00001111,%11100000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000100
	dc.b	%00000011,%10000100
	dc.b	%00001111,%11111000
	dc.b	%00010001,%00110100
	dc.b	%00100110,%01101000
	dc.b	%00101011,%11111000
	dc.b	%01101010,%10001100
	dc.b	%01100001,%00011100
	dc.b	%01110001,%11111100
	dc.b	%01111111,%11111100
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00011111,%11110000
	dc.b	%00001111,%11100000
	dc.b	%00000011,%10000000
	dc.b	%00000000,%00000100
	dc.b	%00000000,%00001110
	dc.b	%00000011,%10001110
	dc.b	%00001111,%11111100
	dc.b	%00011111,%11111100
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%01111111,%11111100
	dc.b	%00111111,%11111000
	dc.b	%00111111,%11111000
	dc.b	%00011111,%11110000
	dc.b	%00001111,%11100000
	dc.b	%00000011,%10000000

;bomb sprite 2
sprite_bomb2:	
	dc.b	%00000000,%00000010
	dc.b	%00000011,%11000111
	dc.b	%00001111,%11111101
	dc.b	%00011111,%11110110
	dc.b	%00111011,%10101100
	dc.b	%00110001,%00011100
	dc.b	%01110011,%10111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%00000000
	dc.b	%00000011,%11000000
	dc.b	%00001111,%11111010
	dc.b	%00011001,%10011000
	dc.b	%00110101,%00110100
	dc.b	%00100011,%11111100
	dc.b	%01000001,%01000110
	dc.b	%01000000,%10001110
	dc.b	%01100000,%11111110
	dc.b	%01110001,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%00000010
	dc.b	%00000011,%11000111
	dc.b	%00001111,%11111111
	dc.b	%00011111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111100
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00001111,%11110000
	dc.b	%00000011,%11000000
;bomb sprite 3
bomberd4@0033
sprite_bomb3:	
	dc.b	%00000111,%11100011
	dc.b	%00011111,%11111100
	dc.b	%00111011,%11111011
	dc.b	%01110001,%11010110
	dc.b	%01110011,%10001110
	dc.b	%11110011,%11011111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000
	dc.b	%00000111,%11100010
	dc.b	%00011100,%11111111
	dc.b	%00110100,%01001101
	dc.b	%01100010,%10011010
	dc.b	%01000000,%11111110
	dc.b	%11001100,%10100011
	dc.b	%10000000,%01000111
	dc.b	%10000000,%01111111
	dc.b	%11000000,%11111111
	dc.b	%11100001,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000
	dc.b	%00000111,%11100011
	dc.b	%00011111,%11111111
	dc.b	%00111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111110
	dc.b	%01111111,%11111110
	dc.b	%00111111,%11111100
	dc.b	%00011111,%11111000
	dc.b	%00000111,%11100000