;*******************************************Handle Horizontal Explosion
;*
;*	This functions handles a horizontal explosion(looks like a -)
;*
;*	Input	d6=the hexp explosion # in the array
;*
;*********
bomberd4@000C:
handle_hexp:
	bsr	learn_hexp
	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_hexp
	move.w	s,(a4)
	rts

learn_hexp:
	lea	bomberd2::hexp_x,a0		;Get hexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::hexp_y,a0		;Get hexp d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::hexp_s,a0		;Get hexp d6's s
	lea	0(a0,d2.w),a4

	lea	bomberd2::hexp_o,a0		;Get hexp d6's o
	lea	0(a0,d2.w),a5


	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s
	move.w	(a5),o

	subq.w	#8,x
	subq.w	#8,y
	rts

bomberd4@000D:
draw_hexp:
	bsr	learn_hexp
		;this code draws the sprite
	cmp.w	#1,s
	beq		hhe_s1
	cmp.w	#2,s
	beq		hhe_s2
	cmp.w	#3,s
	beq		hhe_s3
	cmp.w	#4,s
	beq		hhe_s4
	cmp.w	#5,s
	beq		hhe_s3
	cmp.w	#6,s
	beq		hhe_s2
	cmp.w	#7,s
	beq		hhe_s1
	;bra		delete_hexp
hhe_exit:
	rts

hhe_s1:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_hexp1,x,y,#16
	rts

hhe_s2:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_hexp2,x,y,#16
	rts

hhe_s3:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_hexp3,x,y,#16
	rts

hhe_s4:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_hexp4,x,y,#16
	rts

;*******************************************Delete Horizontal Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the hexp array
;*
;*********
bomberd4@000E:
delete_hexp:

	movem.l	d0/a0-a3,-(a7)

	lea	bomberd2::hexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::hexp_y,a1
	lea	0(a1,d0.w),a1

	lea	bomberd2::hexp_s,a2
	lea	0(a2,d0.w),a2

	lea	bomberd2::hexp_s,a3
	lea	0(a3,d0.w),a3

	move.w	bomberd2::hexpcount,d1
	sub.w	d6,d1
	cmp.w	#0,d1
	beq		dhe_loop_exit
	subq.w	#1,d1

		;this code shifts the data in the array
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
	addq.w	#$02,a3
dhe_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2
	move.w	(a3),d0
	subq.w	#$02,a3
	move.w	d0,(a3)
	addq.w	#$04,a3

	dbra.w	d1,dhe_loop

dhe_loop_exit:
	subq.w	#1,bomberd2::hexpcount

	movem.l	(a7)+,d0/a0-a3
	rts

;*******************************************Add Horizontal Explosion
;*
;*	This functions adds an horiz. explosion to the hexp array
;*
;*	Input:	x=x coordinate(in squares) of the new hexp
;*		y=y coordinate(in squares) of the new hexp
;*		o=owner
;*
;*********
bomberd4@000F:
add_hexp:
	movem.l	d0-d4/a0,-(a7)

	move.w	x,d0
	move.w	y,d1
	GetBoard d2
	SetBoardL #0
	cmp.w	#3,d2
	bne		add_hexp_no_bomb

	mulu.w	#16,d0
	addq.w	#8,d0
	mulu.w	#16,d1
	addq.w	#8,d1

				;this code looks for a bomb under this explosion
				;wherein it will explode it
			move.w	bomberd2::bombcount,d4
			cmp.w	#0,d4
			ble		add_hexp_end_bomb_loop_1
			subq.w	#1,d4
		add_hexp_bomb_loop_1:
			move.w	d4,d3

			lea	bomberd2::bomb_x,a0		;Set hexp x
			mulu.w	#2,d3
			lea	0(a0,d3.w),a0
			move.w	(a0),d2

			cmp.w	d2,d0
			bne		add_hexp_bomb_nope

				lea	bomberd2::bomb_y,a0		;Set hexp y
				lea	0(a0,d3.w),a0
				move.w	(a0),d2

				cmp.w	d2,d1
				bne		add_hexp_bomb_nope

					lea	bomberd2::bomb_es,a0		;Set hexp es
					lea	0(a0,d3.w),a0
					move.w	#2,(a0)

			add_hexp_bomb_nope:

			dbra.w	d4,add_hexp_bomb_loop_1
		add_hexp_end_bomb_loop_1:
		bra	cancel_add_hexp
add_hexp_no_bomb:

	lea	bomberd2::hexp_x,a0		;Set hexp x
	move.w  bomberd2::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::hexp_y,a0		;Set hexp y
	move.w  bomberd2::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::hexp_s,a0		;Set hexp s
	move.w  bomberd2::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomberd2::explife,(a0)

	lea	bomberd2::hexp_o,a0		;Set hexp s
	move.w  bomberd2::hexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	o,(a0)

	addq.w	#1,bomberd2::hexpcount

cancel_add_hexp:
	movem.l	(a7)+,d0-d4/a0
	rts





;the horizontal explosion
sprite_hexp1:	
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00010010,%00100000
	dc.b	%10111111,%01001001
	dc.b	%11111111,%11111111
	dc.b	%11111011,%11111111
	dc.b	%00100001,%11000011
	dc.b	%00000000,%10000001
	dc.b	%01110001,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11011100
	dc.b	%10001100,%00000000
	dc.b	%00100001,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000100,%00000000
	dc.b	%11011110,%00111100
	dc.b	%11111111,%01111110
	dc.b	%10001110,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00010010,%00100000
	dc.b	%10111111,%01001001
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11011100
	dc.b	%10001100,%00000000
	dc.b	%00100001,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000

sprite_hexp2:	
	dc.b	%00000000,%00000000
	dc.b	%00010010,%00000000
	dc.b	%10111111,%00100010
	dc.b	%11111111,%01001001
	dc.b	%11111111,%11111111
	dc.b	%01111001,%11111000
	dc.b	%00000000,%01100000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%01000000,%01000000
	dc.b	%11100000,%11100000
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11001110
	dc.b	%10011100,%00000000
	dc.b	%00100001,%00001000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%10000110,%00000111
	dc.b	%11111111,%10011100
	dc.b	%00110000,%11100000
	dc.b	%01100001,%11100001
	dc.b	%10111111,%10110011
	dc.b	%00011111,%00011111
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00010010,%00000000
	dc.b	%10111111,%00100010
	dc.b	%11111111,%01001001
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11001110
	dc.b	%10011100,%00000000
	dc.b	%00100001,%00001000
	dc.b	%00000000,%00000000

sprite_hexp3:	
	dc.b	%01001000,%00000000
	dc.b	%01110010,%00000100
	dc.b	%11111111,%10111001
	dc.b	%11111111,%11111111
	dc.b	%11000011,%11111111
	dc.b	%00000000,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%01000011,%00000001
	dc.b	%11111111,%11111111
	dc.b	%11111111,%00100010
	dc.b	%11010110,%10001001
	dc.b	%01000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00111100,%00000000
	dc.b	%10000011,%01110000
	dc.b	%00000001,%10000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000001,%00000000
	dc.b	%11000011,%10000001
	dc.b	%10111100,%11111110
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%01001000,%00000000
	dc.b	%01110010,%00000100
	dc.b	%11111111,%10111001
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%00100010
	dc.b	%11010110,%10001001
	dc.b	%01000000,%00000000

sprite_hexp4:	
	dc.b	%10011100,%00000000
	dc.b	%11111111,%11011100
	dc.b	%10001100,%11111111
	dc.b	%00000000,%00100011
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00011100
	dc.b	%11111000,%11111111
	dc.b	%11111111,%11100111
	dc.b	%11000111,%00000001
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%01110011,%00000000
	dc.b	%11110111,%11011100
	dc.b	%01100110,%00000111
	dc.b	%00000100,%00000100
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00001000,%00000100
	dc.b	%00011100,%00001100
	dc.b	%11111110,%01100011
	dc.b	%00000111,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%10011100,%00000000
	dc.b	%11111111,%11011100
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11100111
	dc.b	%11000111,%00000001