;*******************************************Handle X Explosion
;*
;*	This functions handles an x explosion(looks like a plus +)
;*
;*	Input	d6=the xexp explosion # in the array
;*
;*********
bomberd4@0014:
handle_xexp:
	bsr	learn_xexp
	subq.w	#1,s
	cmp.w	#0,s
	beq		delete_xexp
	move.w	s,(a4)
	rts

learn_xexp:
	lea	bomberd2::xexp_x,a0		;Get xexp d6's x
	move.w  d6,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a2

	lea	bomberd2::xexp_y,a0		;Get xexp d6's y
	lea	0(a0,d2.w),a3

	lea	bomberd2::xexp_s,a0		;Get xexp d6's s
	lea	0(a0,d2.w),a4

	move.w	(a2),x
	move.w	(a3),y
	move.w	(a4),s

	subq.w	#8,x
	subq.w	#8,y
	rts

bomberd4@0015:
draw_xexp:
	bsr	learn_xexp
		;draw the xexp sprite
	cmp.w	#1,s
	beq		hxe_s1
	cmp.w	#2,s
	beq		hxe_s2
	cmp.w	#3,s
	beq		hxe_s3
	cmp.w	#4,s
	beq		hxe_s4
	cmp.w	#5,s
	beq		hxe_s3
	cmp.w	#6,s
	beq		hxe_s2
	cmp.w	#7,s
	beq		hxe_s1
	;bra		delete_xexp
	rts

hxe_s1:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_xexp1,x,y,#16
	rts

hxe_s2:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_xexp2,x,y,#16
	rts

hxe_s3:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_xexp3,x,y,#16
	rts

hxe_s4:
	Draw2ByteSpriteToBufferMaskFromLib	sprite_xexp4,x,y,#16
	rts

;*******************************************Delete X Explosion
;*
;*	This functions deletes an explosion
;*
;*	Input:	d6=the number of the sprite in the xexp array
;*
;*********
bomberd4@0016:
delete_xexp:

	movem.l	d0/a0-a2,-(a7)

	lea	bomberd2::xexp_x,a0
	move.w  d6,d0
	mulu.w	#2,d0
	lea	0(a0,d0.w),a0

	lea	bomberd2::xexp_y,a1
	lea	0(a1,d0.w),a1

	lea	bomberd2::xexp_s,a2
	lea	0(a2,d0.w),a2

	move.w	bomberd2::xexpcount,d1
	sub.w	d6,d1
	cmp.w	#0,d1
	beq		dxe_loop_exit
	subq.w	#1,d1

		;this code shifts the array one less starting at the posiion of this sprite
	addq.w	#$02,a0
	addq.w	#$02,a1
	addq.w	#$02,a2
dxe_loop:
	
	move.w	(a0),d0
	subq.w	#$02,a0
	move.w	d0,(a0)
	addq.w	#$04,a0
	move.w	(a1),d0
	subq.w	#$02,a1
	move.w	d0,(a1)
	addq.w	#$04,a1
	move.w	(a2),d0
	subq.w	#$02,a2
	move.w	d0,(a2)
	addq.w	#$04,a2

	dbra.w	d1,dxe_loop

dxe_loop_exit:
	subq.w	#1,bomberd2::xexpcount

	movem.l	(a7)+,d0/a0-a2
	rts

;*******************************************Add X Explosion
;*
;*	This functions adds an x explosion to the xexp array
;*
;*	Input:	x=x coordinate(in squares) of the new xexp
;*		y=y coordinate(in squares) of the new xexp
;*
;*********
bomberd4@0017:
add_xexp:
	movem.l	d0-d2/a0,-(a7)

	lea	bomberd2::xexp_x,a0		;Set xexp x
	move.w  bomberd2::xexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	x,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::xexp_y,a0		;Set xexp y
	move.w  bomberd2::xexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	y,d2
	mulu.w	#16,d2
	addq.w	#8,d2
	move.w	d2,(a0)

	lea	bomberd2::xexp_s,a0		;Set xexp s
	move.w  bomberd2::xexpcount,d2
	mulu.w	#2,d2
	lea	0(a0,d2.w),a0
	move.w	bomberd2::explife,(a0)

	movem.l	(a7)+,d0-d2/a0

	addq.w	#1,bomberd2::xexpcount
	rts





;the x explosion
sprite_xexp1:	
	dc.b	%00011100,%00111000
	dc.b	%01001100,%00111010
	dc.b	%00011100,%00011001
	dc.b	%00111100,%00011100
	dc.b	%11111001,%10001111
	dc.b	%11110011,%11000111
	dc.b	%00110110,%00000111
	dc.b	%00000100,%00000000
	dc.b	%00001000,%00001000
	dc.b	%00001000,%00001000
	dc.b	%10100100,%00001011
	dc.b	%11111000,%00011111
	dc.b	%01111100,%00111111
	dc.b	%00011111,%00111110
	dc.b	%00001100,%00111000
	dc.b	%01001100,%00110010
	dc.b	%00000011,%11000000
	dc.b	%00000011,%11000000
	dc.b	%00000011,%11100000
	dc.b	%00000011,%11100000
	dc.b	%00000110,%01110000
	dc.b	%00001100,%00111000
	dc.b	%11001001,%11111000
	dc.b	%11111011,%01111111
	dc.b	%11110110,%00110111
	dc.b	%11110110,%00110111
	dc.b	%01011011,%01110100
	dc.b	%00000111,%11100000
	dc.b	%00000011,%11000000
	dc.b	%00000000,%11000000
	dc.b	%00000011,%11000000
	dc.b	%00000011,%11000000
	dc.b	%00011111,%11111000
	dc.b	%01001111,%11111010
	dc.b	%00011111,%11111001
	dc.b	%00111111,%11111100
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00011111,%11111110
	dc.b	%00001111,%11111000
	dc.b	%01001111,%11110010

sprite_xexp2:	
	dc.b	%00011100,%00011100
	dc.b	%01111100,%00011111
	dc.b	%01111100,%00011111
	dc.b	%11110000,%00011111
	dc.b	%11110000,%00001111
	dc.b	%00010000,%00000110
	dc.b	%00000000,%00000100
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%11000000,%00000001
	dc.b	%11110000,%00000011
	dc.b	%11110000,%00000111
	dc.b	%01111000,%00001111
	dc.b	%00111000,%00111110
	dc.b	%10011100,%00111101
	dc.b	%00000010,%00100000
	dc.b	%00000010,%00100000
	dc.b	%00000011,%11100000
	dc.b	%00001111,%11100000
	dc.b	%00001100,%00110000
	dc.b	%11101110,%00111001
	dc.b	%11111100,%00011011
	dc.b	%00011001,%00011110
	dc.b	%00111001,%10011110
	dc.b	%11111001,%10010111
	dc.b	%00111100,%00010110
	dc.b	%00001110,%00101100
	dc.b	%00001111,%11111000
	dc.b	%00000111,%11110000
	dc.b	%00000110,%01000000
	dc.b	%00000010,%01000000
	dc.b	%00011111,%11111100
	dc.b	%01111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110
	dc.b	%10011111,%11111101

sprite_xexp3:	
	dc.b	%00110000,%00001110
	dc.b	%01110000,%00001111
	dc.b	%11100000,%00001111
	dc.b	%11000000,%00000111
	dc.b	%10000000,%00000001
	dc.b	%10000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%10000000,%00000111
	dc.b	%11100000,%00000111
	dc.b	%01110000,%00000111
	dc.b	%00111110,%00000110
	dc.b	%00001000,%00110000
	dc.b	%00001000,%01110000
	dc.b	%00011001,%11110000
	dc.b	%00110000,%00011000
	dc.b	%01100000,%00001110
	dc.b	%01100000,%00000111
	dc.b	%10100000,%00000010
	dc.b	%00000000,%00000010
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00010000,%00000000
	dc.b	%11110000,%00001111
	dc.b	%01111000,%00011000
	dc.b	%00011110,%00111000
	dc.b	%00001111,%10011000
	dc.b	%00000000,%00011000
	dc.b	%00111111,%11111110
	dc.b	%01111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%01111111,%11111111
	dc.b	%00111111,%11111110

sprite_xexp4:	
	dc.b	%11000000,%00000011
	dc.b	%10000000,%00000011
	dc.b	%00000000,%00000001
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%10000000,%00000001
	dc.b	%11000000,%00000011
	dc.b	%11100000,%00000111
	dc.b	%00111000,%00001100
	dc.b	%01100000,%00011100
	dc.b	%11000000,%00000110
	dc.b	%10000000,%00000011
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%00000000,%00000000
	dc.b	%10000000,%00000011
	dc.b	%01000000,%00000110
	dc.b	%00100000,%00000100
	dc.b	%00011100,%00001000
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111
	dc.b	%11111111,%11111111